Codeforces Round 923 (Div. 3) A-E

2024-02-10 06:12
文章标签 codeforces round div 923

本文主要是介绍Codeforces Round 923 (Div. 3) A-E,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

链接

Dashboard - Codeforces Round 923 (Div. 3) - Codeforces

A. Make it White

题意:给定一个n长的字符串s,s中包含W和B,可以选定一个区间,使得其中所有的B变为W,求让所有B变为W的最小区间

思路:选定最早的B和最晚的B就是这个区间长度了

代码:

#include <bits/stdc++.h>
#define ll long long
#define endl '\n'
using namespace std;
const int N=1e5+7;
int n,q;
ll a[N],temp[N],ans[105];inline void solve()
{cin>>n;string s;cin>>s;int minn=1e9,maxn=-1;for(int i=0;i<s.length();i++){if(s[i]=='B'){minn=min(minn,i);maxn=max(maxn,i);}}ll ans=maxn-minn+1;cout<<max(0LL,ans)<<endl;
}int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin>>t;while(t--){solve(); }return 0;
}

B. Following the String

题意:存在一个n长的字符串s,给了一个数组a,其中ai表示si前面有多少个字符和si一样。

思路:暴力模拟,用个book标记一下,book[i]表示i+‘a’出现了多少次。

代码:

#include <bits/stdc++.h>
#define ll long long
#define endl '\n'
using namespace std;
const int N=1e5+7;
int n,q;
ll a[N],temp[N],ans[105];inline void solve()
{int n;cin>>n;vector<int> book(n+1);string s="";for(int i=1;i<=n;i++){int x;cin>>x;s+=(char)(book[x]+'a');book[x]++;}cout<<s<<endl;
}int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin>>t;while(t--){solve(); }return 0;
}

C. Choose the Different Ones!

题意:给定n,m,k,n个数字的a数组,m个数字的b数组,询问是否可以各取k/2个数组,组成一个新的数组包含1-k

思路:首先要求a有k/2个及以上1-k的数组,对b也是;这些数组分别对于a、b重复的是不累加的,然后再扫一遍看看是否1-k都有了就行了

代码:

#include <bits/stdc++.h>
#define ll long long
//#define endl '\n'
using namespace std;
const int N=1e5+7;inline void solve()
{int n,m,k;cin>>n>>m>>k;set<int> a,b;int cnta=0,cntb=0;vector<int> book(k+1);for(int i=1;i<=n;i++){int x;cin>>x;if(1<=x&&x<=k){if(a.find(x)==a.end()){cnta++;book[x]=1;a.insert(x);}}}for(int i=1;i<=m;i++){int x;cin>>x;if(1<=x&&x<=k){if(b.find(x)==b.end()){cntb++;book[x]=1;b.insert(x);}}}	if(cnta>=k/2&&cntb>=k/2){for(int i=1;i<=k;i++){if(!book[i]){cout<<"NO"<<endl;return;}}cout<<"YES"<<endl;return;}//cout<<"this"<<endl;cout<<"NO"<<endl;
}int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin>>t;while(t--){solve(); }return 0;
}

D. Find the Different Ones!

题意:给定一个数组a有n个数字,然后有q个询问,每次询问给出一个l和r,要求对于数组a[l]到a[r]是否存在下标x,y使得a[x]!=a[y],同时l<=x<y<=r.

思路:对于每一个下标,预处理他的左边第一个和他不一样的位置就行,如果和前一个不一样就是前一个,不然就等于前一个的不一样的位置,因为此时是和前一个一样的,直接继承就可以了。

代码:

#include <bits/stdc++.h>
#define ll long long
//#define endl '\n'
using namespace std;
const int N=2e5+7;int n,q;int a[N];inline void solve()
{cin>>n;for(int i=1;i<=n;i++){cin>>a[i];}vector<int> p(n+1);p[1]=0;for(int i=2;i<=n;i++){p[i]=p[i-1];if(a[i]!=a[i-1]){p[i]=i-1;}}cin>>q;while(q--){int l,r;cin>>l>>r;if(p[r]<l){cout<<"-1 -1"<<endl;}else{cout<<p[r]<<" "<<r<<endl; }}
}int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin>>t;while(t--){solve(); }return 0;
}

E. Klever Permutation

题意:给定n和k,要求利用1-n的数字去构造一个长为n的数组,数字不重复,同时对于任意一对长为k的区间的和,要求差不超过1。

思路:要求差不超过1,说明只能构造数组s,si代表ai-ai+k-1的区间和,si=s(i+1)+1或者si=s(i+1)-1,可以是连续的下降或者是一起一落。

然后对于相邻的si和si+1,区别就是ai和ai+k相差1,对于每个i去构造n/k个数字就行了。

代码:

#include <bits/stdc++.h>
#define ll long long
//#define endl '\n'
using namespace std;
const int N=2e5+7;int n,k;int a[N];inline void solve()
{int n,k;cin>>n>>k;int l=1,r=n;vector<int> ans(n+1);for(int i=1;i<=k;i++){for(int j=i;j<=n;j+=k){if(i%2==1){ans[j]=l;l++;}else{ans[j]=r;r--;}}}for(int i=1;i<=n;i++) cout<<ans[i]<<" ";cout<<endl;
}int main()
{ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin>>t;while(t--){solve(); }return 0;
}

这篇关于Codeforces Round 923 (Div. 3) A-E的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/696332

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There